diff -ruN qmail-1.03-orig/digest_sha1.c qmail-1.03-ldap-20060201-orig/digest_sha1.c
--- qmail-1.03-orig/digest_sha1.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/digest_sha1.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,247 @@
+/* digest_sha1.c for QLDAP modified to use djb stuff    */
+/* contains SHA1 algorithm stolen directly from OpenBSD */
+/*	$OpenBSD: sha1.c,v 1.11 2003/01/08 19:53:59 millert Exp $	*/
+
+/*        */
+/*  SHA1  */
+/*        */
+
+/*
+ * SHA-1 in C
+ * By Steve Reid <steve@edmweb.com>
+ * 100% Public Domain
+ *
+ * Test Vectors (from FIPS PUB 180-1)
+ * "abc"
+ *   A9993E36 4706816A BA3E2571 7850C26C 9CD0D89D
+ * "abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq"
+ *   84983E44 1C3BD26E BAAE4AA1 F95129E5 E54670F1
+ * A million repetitions of "a"
+ *   34AA973C D4C4DAA4 F61EEB2B DBAD2731 6534016F
+ */
+
+#define SHA1HANDSOFF            /* Copies data before messing with it. */
+
+#include <sys/types.h>
+#include "uint32.h"
+#include "byte.h"
+#include "digest_sha1.h"
+
+#define rol(value, bits) (((value) << (bits)) | ((value) >> (32 - (bits))))
+
+/*
+ * blk0() and blk() perform the initial expand.
+ * I got the idea of expanding during the round function from SSLeay
+ */
+#ifdef __LITTLE_ENDIAN__
+# define blk0(i) (block->l[i] = (rol(block->l[i],24)&0xFF00FF00) \
+    |(rol(block->l[i],8)&0x00FF00FF))
+#else  /* __BIG_ENDIAN__ */
+# define blk0(i) block->l[i]
+#endif /* __LITTLE_ENDIAN__ */
+
+#define blk(i) (block->l[i&15] = rol(block->l[(i+13)&15]^block->l[(i+8)&15] \
+    ^block->l[(i+2)&15]^block->l[i&15],1))
+
+/*
+ * (R0+R1), R2, R3, R4 are the different operations (rounds) used in SHA1
+ */
+#define R0(v,w,x,y,z,i) z+=((w&(x^y))^y)+blk0(i)+0x5A827999+rol(v,5);w=rol(w,30);
+#define R1(v,w,x,y,z,i) z+=((w&(x^y))^y)+blk(i)+0x5A827999+rol(v,5);w=rol(w,30);
+#define R2(v,w,x,y,z,i) z+=(w^x^y)+blk(i)+0x6ED9EBA1+rol(v,5);w=rol(w,30);
+#define R3(v,w,x,y,z,i) z+=(((w|x)&y)|(w&x))+blk(i)+0x8F1BBCDC+rol(v,5);w=rol(w,30);
+#define R4(v,w,x,y,z,i) z+=(w^x^y)+blk(i)+0xCA62C1D6+rol(v,5);w=rol(w,30);
+
+typedef union {
+    unsigned char c[64];
+    uint32 l[16];
+} CHAR64LONG16;
+
+#ifdef __sparc_v9__
+static void do_R01(uint32 *a, uint32 *b, uint32 *c, uint32 *d, uint32 *e, CHAR64LONG16 *);
+static void do_R2(uint32 *a, uint32 *b, uint32 *c, uint32 *d, uint32 *e, CHAR64LONG16 *);
+static void do_R3(uint32 *a, uint32 *b, uint32 *c, uint32 *d, uint32 *e, CHAR64LONG16 *);
+static void do_R4(uint32 *a, uint32 *b, uint32 *c, uint32 *d, uint32 *e, CHAR64LONG16 *);
+
+#define nR0(v,w,x,y,z,i) R0(*v,*w,*x,*y,*z,i)
+#define nR1(v,w,x,y,z,i) R1(*v,*w,*x,*y,*z,i)
+#define nR2(v,w,x,y,z,i) R2(*v,*w,*x,*y,*z,i)
+#define nR3(v,w,x,y,z,i) R3(*v,*w,*x,*y,*z,i)
+#define nR4(v,w,x,y,z,i) R4(*v,*w,*x,*y,*z,i)
+
+static void
+do_R01(uint32 *a, uint32 *b, uint32 *c, uint32 *d, uint32 *e, CHAR64LONG16 *block)
+{
+    nR0(a,b,c,d,e, 0); nR0(e,a,b,c,d, 1); nR0(d,e,a,b,c, 2); nR0(c,d,e,a,b, 3);
+    nR0(b,c,d,e,a, 4); nR0(a,b,c,d,e, 5); nR0(e,a,b,c,d, 6); nR0(d,e,a,b,c, 7);
+    nR0(c,d,e,a,b, 8); nR0(b,c,d,e,a, 9); nR0(a,b,c,d,e,10); nR0(e,a,b,c,d,11);
+    nR0(d,e,a,b,c,12); nR0(c,d,e,a,b,13); nR0(b,c,d,e,a,14); nR0(a,b,c,d,e,15);
+    nR1(e,a,b,c,d,16); nR1(d,e,a,b,c,17); nR1(c,d,e,a,b,18); nR1(b,c,d,e,a,19);
+}
+
+static void
+do_R2(uint32 *a, uint32 *b, uint32 *c, uint32 *d, uint32 *e, CHAR64LONG16 *block)
+{
+    nR2(a,b,c,d,e,20); nR2(e,a,b,c,d,21); nR2(d,e,a,b,c,22); nR2(c,d,e,a,b,23);
+    nR2(b,c,d,e,a,24); nR2(a,b,c,d,e,25); nR2(e,a,b,c,d,26); nR2(d,e,a,b,c,27);
+    nR2(c,d,e,a,b,28); nR2(b,c,d,e,a,29); nR2(a,b,c,d,e,30); nR2(e,a,b,c,d,31);
+    nR2(d,e,a,b,c,32); nR2(c,d,e,a,b,33); nR2(b,c,d,e,a,34); nR2(a,b,c,d,e,35);
+    nR2(e,a,b,c,d,36); nR2(d,e,a,b,c,37); nR2(c,d,e,a,b,38); nR2(b,c,d,e,a,39);
+}
+
+static void
+do_R3(uint32 *a, uint32 *b, uint32 *c, uint32 *d, uint32 *e, CHAR64LONG16 *block)
+{
+    nR3(a,b,c,d,e,40); nR3(e,a,b,c,d,41); nR3(d,e,a,b,c,42); nR3(c,d,e,a,b,43);
+    nR3(b,c,d,e,a,44); nR3(a,b,c,d,e,45); nR3(e,a,b,c,d,46); nR3(d,e,a,b,c,47);
+    nR3(c,d,e,a,b,48); nR3(b,c,d,e,a,49); nR3(a,b,c,d,e,50); nR3(e,a,b,c,d,51);
+    nR3(d,e,a,b,c,52); nR3(c,d,e,a,b,53); nR3(b,c,d,e,a,54); nR3(a,b,c,d,e,55);
+    nR3(e,a,b,c,d,56); nR3(d,e,a,b,c,57); nR3(c,d,e,a,b,58); nR3(b,c,d,e,a,59);
+}
+
+static void
+do_R4(uint32 *a, uint32 *b, uint32 *c, uint32 *d, uint32 *e, CHAR64LONG16 *block)
+{
+    nR4(a,b,c,d,e,60); nR4(e,a,b,c,d,61); nR4(d,e,a,b,c,62); nR4(c,d,e,a,b,63);
+    nR4(b,c,d,e,a,64); nR4(a,b,c,d,e,65); nR4(e,a,b,c,d,66); nR4(d,e,a,b,c,67);
+    nR4(c,d,e,a,b,68); nR4(b,c,d,e,a,69); nR4(a,b,c,d,e,70); nR4(e,a,b,c,d,71);
+    nR4(d,e,a,b,c,72); nR4(c,d,e,a,b,73); nR4(b,c,d,e,a,74); nR4(a,b,c,d,e,75);
+    nR4(e,a,b,c,d,76); nR4(d,e,a,b,c,77); nR4(c,d,e,a,b,78); nR4(b,c,d,e,a,79);
+}
+#endif
+
+/*
+ * Hash a single 512-bit block. This is the core of the algorithm.
+ */
+static void
+SHA1Transform(uint32 state[5], const unsigned char buffer[64])
+{
+    uint32 a, b, c, d, e;
+    CHAR64LONG16 *block;
+
+#ifdef SHA1HANDSOFF
+    static CHAR64LONG16 workspace;
+    block = &workspace;
+    byte_copy(block, 64, buffer);
+#else
+    block = (CHAR64LONG16 *)buffer;
+#endif
+
+    /* Copy context->state[] to working vars */
+    a = state[0];
+    b = state[1];
+    c = state[2];
+    d = state[3];
+    e = state[4];
+
+#ifdef __sparc_v9__
+    do_R01(&a, &b, &c, &d, &e, block);
+    do_R2(&a, &b, &c, &d, &e, block);
+    do_R3(&a, &b, &c, &d, &e, block);
+    do_R4(&a, &b, &c, &d, &e, block);
+#else
+    /* 4 rounds of 20 operations each. Loop unrolled. */
+    R0(a,b,c,d,e, 0); R0(e,a,b,c,d, 1); R0(d,e,a,b,c, 2); R0(c,d,e,a,b, 3);
+    R0(b,c,d,e,a, 4); R0(a,b,c,d,e, 5); R0(e,a,b,c,d, 6); R0(d,e,a,b,c, 7);
+    R0(c,d,e,a,b, 8); R0(b,c,d,e,a, 9); R0(a,b,c,d,e,10); R0(e,a,b,c,d,11);
+    R0(d,e,a,b,c,12); R0(c,d,e,a,b,13); R0(b,c,d,e,a,14); R0(a,b,c,d,e,15);
+    R1(e,a,b,c,d,16); R1(d,e,a,b,c,17); R1(c,d,e,a,b,18); R1(b,c,d,e,a,19);
+    R2(a,b,c,d,e,20); R2(e,a,b,c,d,21); R2(d,e,a,b,c,22); R2(c,d,e,a,b,23);
+    R2(b,c,d,e,a,24); R2(a,b,c,d,e,25); R2(e,a,b,c,d,26); R2(d,e,a,b,c,27);
+    R2(c,d,e,a,b,28); R2(b,c,d,e,a,29); R2(a,b,c,d,e,30); R2(e,a,b,c,d,31);
+    R2(d,e,a,b,c,32); R2(c,d,e,a,b,33); R2(b,c,d,e,a,34); R2(a,b,c,d,e,35);
+    R2(e,a,b,c,d,36); R2(d,e,a,b,c,37); R2(c,d,e,a,b,38); R2(b,c,d,e,a,39);
+    R3(a,b,c,d,e,40); R3(e,a,b,c,d,41); R3(d,e,a,b,c,42); R3(c,d,e,a,b,43);
+    R3(b,c,d,e,a,44); R3(a,b,c,d,e,45); R3(e,a,b,c,d,46); R3(d,e,a,b,c,47);
+    R3(c,d,e,a,b,48); R3(b,c,d,e,a,49); R3(a,b,c,d,e,50); R3(e,a,b,c,d,51);
+    R3(d,e,a,b,c,52); R3(c,d,e,a,b,53); R3(b,c,d,e,a,54); R3(a,b,c,d,e,55);
+    R3(e,a,b,c,d,56); R3(d,e,a,b,c,57); R3(c,d,e,a,b,58); R3(b,c,d,e,a,59);
+    R4(a,b,c,d,e,60); R4(e,a,b,c,d,61); R4(d,e,a,b,c,62); R4(c,d,e,a,b,63);
+    R4(b,c,d,e,a,64); R4(a,b,c,d,e,65); R4(e,a,b,c,d,66); R4(d,e,a,b,c,67);
+    R4(c,d,e,a,b,68); R4(b,c,d,e,a,69); R4(a,b,c,d,e,70); R4(e,a,b,c,d,71);
+    R4(d,e,a,b,c,72); R4(c,d,e,a,b,73); R4(b,c,d,e,a,74); R4(a,b,c,d,e,75);
+    R4(e,a,b,c,d,76); R4(d,e,a,b,c,77); R4(c,d,e,a,b,78); R4(b,c,d,e,a,79);
+#endif
+
+    /* Add the working vars back into context.state[] */
+    state[0] += a;
+    state[1] += b;
+    state[2] += c;
+    state[3] += d;
+    state[4] += e;
+
+    /* Wipe variables */
+    a = b = c = d = e = 0;
+}
+
+/*
+ * SHA1Init - Initialize new context
+ */
+void
+SHA1Init(SHA1_CTX *context)
+{
+
+    /* SHA1 initialization constants */
+    context->state[0] = 0x67452301;
+    context->state[1] = 0xEFCDAB89;
+    context->state[2] = 0x98BADCFE;
+    context->state[3] = 0x10325476;
+    context->state[4] = 0xC3D2E1F0;
+    context->count[0] = context->count[1] = 0;
+}
+
+
+/*
+ * Run your data through this.
+ */
+void
+SHA1Update(SHA1_CTX *context, const unsigned char *data, size_t len)
+{
+    unsigned int i, j;
+
+    j = context->count[0];
+    if ((context->count[0] += len << 3) < j)
+        context->count[1] += (len>>29)+1;
+    j = (j >> 3) & 63;
+    if ((j + len) > 63) {
+        byte_copy(&context->buffer[j], (i = 64-j), data);
+        SHA1Transform(context->state, context->buffer);
+        for ( ; i + 63 < len; i += 64)
+            SHA1Transform(context->state, &data[i]);
+        j = 0;
+    } else {
+        i = 0;
+    }
+    byte_copy(&context->buffer[j], len - i, &data[i]);
+}
+
+
+/*
+ * Add padding and return the message digest.
+ */
+void
+SHA1Final(unsigned char digest[SHA1_LEN], SHA1_CTX *context)
+{
+    unsigned int i;
+    unsigned char finalcount[8];
+
+    for (i = 0; i < 8; i++) {
+        finalcount[i] = (unsigned char)((context->count[(i >= 4 ? 0 : 1)]
+         >> ((3-(i & 3)) * 8) ) & 255);  /* Endian independent */
+    }
+    SHA1Update(context, (const unsigned char *)"\200", 1);
+    while ((context->count[0] & 504) != 448)
+        SHA1Update(context, (const unsigned char *)"\0", 1);
+    SHA1Update(context, finalcount, 8);  /* Should cause a SHA1Transform() */
+
+    if (digest) {
+        for (i = 0; i < 20; i++)
+            digest[i] = (unsigned char)
+                ((context->state[i>>2] >> ((3-(i & 3)) * 8) ) & 255);
+        /* Zeroize sensitive information.
+         */
+        byte_zero(context, sizeof (*context));
+	}
+	
+}
+
diff -ruN qmail-1.03-orig/digest_sha1.h qmail-1.03-ldap-20060201-orig/digest_sha1.h
--- qmail-1.03-orig/digest_sha1.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/digest_sha1.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,30 @@
+/* digest_sha1.h for QLDAP modified to use djb stuff */
+
+/*        */
+/*  SHA1  */
+/*        */
+
+/*
+ * SHA-1 in C
+ * By Steve Reid <steve@edmweb.com>
+ * 100% Public Domain
+ */
+
+#ifndef _SHA1_H
+#define _SHA1_H
+
+#include "uint32.h"
+
+typedef struct {
+    uint32 state[5];
+    uint32 count[2];  
+    unsigned char buffer[64];
+} SHA1_CTX;
+ 
+#define SHA1_LEN 20
+
+void SHA1Init(SHA1_CTX *);
+void SHA1Update(SHA1_CTX *, const unsigned char *, size_t);
+void SHA1Final(unsigned char [SHA1_LEN], SHA1_CTX *);
+
+#endif /* _SHA1_H */
diff -ruN qmail-1.03-orig/dirmaker qmail-1.03-ldap-20060201-orig/dirmaker
--- qmail-1.03-orig/dirmaker	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/dirmaker	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,5 @@
+#!/bin/sh
+# public domain
+#
+/bin/mkdir -m 700 -p $1
+#EOF
diff -ruN qmail-1.03-orig/dirmaker.c qmail-1.03-ldap-20060201-orig/dirmaker.c
--- qmail-1.03-orig/dirmaker.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/dirmaker.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,99 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifdef AUTOHOMEDIRMAKE
+#include <sys/types.h>
+#include <unistd.h>
+
+#include "error.h"
+#include "control.h"
+#include "open.h"
+#include "qldap-debug.h"
+#include "qldap-errno.h"
+#include "qlx.h"
+#include "stralloc.h"
+#include "wait.h"
+
+#include "dirmaker.h"
+
+
+static stralloc	dirmaker = {0};
+
+int
+dirmaker_init(void)
+/* ~control/dirmaker SHOULD to be only writeable for root */
+{
+	if (control_rldef(&dirmaker, "control/dirmaker", 0, "") == -1)
+		return -1;
+	if (!stralloc_0(&dirmaker))
+		return -1;
+	logit(64, "init: control/dirmaker: %s\n", dirmaker.s);
+	return 0;
+}
+
+int
+dirmaker_make(const char *home, const char *maildir)
+{
+	char *(dirargs[3]);
+	int child, wstat;
+
+	if (dirmaker.s == 0 || dirmaker.len < 2)
+		return MAILDIR_UNCONF;
+	
+	switch(child = fork()) {
+		case -1:
+			if (error_temp(errno)) return MAILDIR_FAILED;
+			return MAILDIR_HARD;
+		case 0:
+			dirargs[0] = dirmaker.s; dirargs[1] = (char *)home;
+			dirargs[2] = (char *)maildir; dirargs[3] = 0;
+			execvp(*dirargs,dirargs);
+			if (error_temp(errno)) _exit(QLX_EXECSOFT);
+			_exit(QLX_EXECHARD);
+	}
+
+	wait_pid(&wstat,child);
+	if (wait_crashed(wstat)) {
+		return MAILDIR_CRASHED;
+	}
+	switch(wait_exitcode(wstat)) {
+		case 0:
+			return OK;
+		case 100: case QLX_EXECHARD:
+			return MAILDIR_HARD;
+		default:
+			return MAILDIR_FAILED;
+	}
+}
+#endif
+
diff -ruN qmail-1.03-orig/dirmaker.h qmail-1.03-ldap-20060201-orig/dirmaker.h
--- qmail-1.03-orig/dirmaker.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/dirmaker.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __DIRMAKER_H__
+#define __DIRMAKER_H__
+
+/* init handler */
+int dirmaker_init(void);
+
+/* executes the dirmaker returns OK on success */
+int dirmaker_make(const char *, const char *);
+
+#endif
diff -ruN qmail-1.03-orig/dns.c qmail-1.03-ldap-20060201-orig/dns.c
--- qmail-1.03-orig/dns.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/dns.c	2006-02-25 11:00:55.000000000 +0100
@@ -7,8 +7,8 @@
 #include <errno.h>
 extern int res_query();
 extern int res_search();
-extern int errno;
 extern int h_errno;
+#include "errno.h"
 #include "ip.h"
 #include "ipalloc.h"
 #include "fmt.h"
@@ -17,14 +17,20 @@
 #include "stralloc.h"
 #include "dns.h"
 #include "case.h"
+#ifdef IGNOREVERISIGN
+#include "byte.h"
+#define FUCKVERISIGN 
+#endif
 
 static unsigned short getshort(c) unsigned char *c;
 { unsigned short u; u = c[0]; return (u << 8) + c[1]; }
 
-static union { HEADER hdr; unsigned char buf[PACKETSZ]; } response;
+static struct { unsigned char *buf; } response;
+static int responsebuflen = 0;
 static int responselen;
 static unsigned char *responseend;
 static unsigned char *responsepos;
+static u_long saveresoptions;
 
 static int numanswers;
 static char name[MAXDNAME];
@@ -45,18 +51,35 @@
  errno = 0;
  if (!stralloc_copy(&glue,domain)) return DNS_MEM;
  if (!stralloc_0(&glue)) return DNS_MEM;
- responselen = lookup(glue.s,C_IN,type,response.buf,sizeof(response));
+ if (!responsebuflen) {
+  if ((response.buf = (unsigned char *)alloc(PACKETSZ+1)))
+   responsebuflen = PACKETSZ+1;
+  else return DNS_MEM;
+ }
+ 
+ responselen = lookup(glue.s,C_IN,type,response.buf,responsebuflen);
+ if ((responselen >= responsebuflen) ||
+     (responselen > 0 && (((HEADER *)response.buf)->tc)))
+  {
+   if (responsebuflen < 65536) {
+    if (alloc_re((char **)&response.buf, responsebuflen, 65536))
+     responsebuflen = 65536;
+    else return DNS_MEM;
+    saveresoptions = _res.options;
+    _res.options |= RES_USEVC;
+    responselen = lookup(glue.s,C_IN,type,response.buf,responsebuflen);
+    _res.options = saveresoptions;
+   }
+  }
  if (responselen <= 0)
   {
    if (errno == ECONNREFUSED) return DNS_SOFT;
    if (h_errno == TRY_AGAIN) return DNS_SOFT;
    return DNS_HARD;
   }
- if (responselen >= sizeof(response))
-   responselen = sizeof(response);
  responseend = response.buf + responselen;
  responsepos = response.buf + sizeof(HEADER);
- n = ntohs(response.hdr.qdcount);
+ n = ntohs(((HEADER *)response.buf)->qdcount);
  while (n-- > 0)
   {
    i = dn_expand(response.buf,responseend,responsepos,name,MAXDNAME);
@@ -66,7 +89,7 @@
    if (i < QFIXEDSZ) return DNS_SOFT;
    responsepos += QFIXEDSZ;
   }
- numanswers = ntohs(response.hdr.ancount);
+ numanswers = ntohs(((HEADER *)response.buf)->ancount);
  return 0;
 }
 
@@ -219,32 +242,32 @@
 
 #define FMT_IAA 40
 
-static int iaafmt(s,ip)
+static int iaafmt(s,tip)
 char *s;
-struct ip_address *ip;
+struct ip_address *tip;
 {
  unsigned int i;
  unsigned int len;
  len = 0;
- i = fmt_ulong(s,(unsigned long) ip->d[3]); len += i; if (s) s += i;
+ i = fmt_ulong(s,(unsigned long) tip->d[3]); len += i; if (s) s += i;
  i = fmt_str(s,"."); len += i; if (s) s += i;
- i = fmt_ulong(s,(unsigned long) ip->d[2]); len += i; if (s) s += i;
+ i = fmt_ulong(s,(unsigned long) tip->d[2]); len += i; if (s) s += i;
  i = fmt_str(s,"."); len += i; if (s) s += i;
- i = fmt_ulong(s,(unsigned long) ip->d[1]); len += i; if (s) s += i;
+ i = fmt_ulong(s,(unsigned long) tip->d[1]); len += i; if (s) s += i;
  i = fmt_str(s,"."); len += i; if (s) s += i;
- i = fmt_ulong(s,(unsigned long) ip->d[0]); len += i; if (s) s += i;
+ i = fmt_ulong(s,(unsigned long) tip->d[0]); len += i; if (s) s += i;
  i = fmt_str(s,".in-addr.arpa."); len += i; if (s) s += i;
  return len;
 }
 
-int dns_ptr(sa,ip)
+int dns_ptr(sa,tip)
 stralloc *sa;
-struct ip_address *ip;
+struct ip_address *tip;
 {
  int r;
 
- if (!stralloc_ready(sa,iaafmt((char *) 0,ip))) return DNS_MEM;
- sa->len = iaafmt(sa->s,ip);
+ if (!stralloc_ready(sa,iaafmt((char *) 0,tip))) return DNS_MEM;
+ sa->len = iaafmt(sa->s,tip);
  switch(resolve(sa,T_PTR))
   {
    case DNS_MEM: return DNS_MEM;
@@ -263,13 +286,22 @@
  return DNS_HARD;
 }
 
-static int dns_ipplus(ia,sa,pref)
+#ifdef FUCKVERISIGN
+static stralloc tld = {0};
+static ipalloc  tldia = {0};
+#endif
+
+static int dns_ipplus(ia,sa,spref)
 ipalloc *ia;
 stralloc *sa;
-int pref;
+int spref;
 {
  int r;
  struct ip_mx ix;
+#ifdef FUCKVERISIGN
+ unsigned int j;
+ struct ip_mx tldix;
+#endif
 
  if (!stralloc_copy(&glue,sa)) return DNS_MEM;
  if (!stralloc_0(&glue)) return DNS_MEM;
@@ -280,8 +312,35 @@
      if (!ipalloc_append(ia,&ix)) return DNS_MEM;
      return 0;
     }
+
  }
 
+#ifdef FUCKVERISIGN
+   j = byte_rchr(sa->s,sa->len,'.');
+   if (j+2 < sa->len) {
+     if(!stralloc_copys(&tld, "*")) return DNS_MEM;
+     if(!stralloc_catb(&tld, sa->s+j, sa->len-j)) return DNS_MEM;
+     switch(resolve(&tld,T_A))
+     {
+       case DNS_HARD: tldia.len = 0; break;
+       case DNS_MEM: return DNS_MEM;
+       case DNS_SOFT: return DNS_SOFT;
+       default:
+         if (!ipalloc_readyplus(&tldia,0)) return DNS_MEM;
+	 tldia.len = 0;
+	 tldix.pref = 0;
+         while ((r = findip(T_A)) != 2)
+         {
+           if (r == DNS_SOFT) return DNS_SOFT;
+           if (r == 1) {
+	     tldix.ip = ip;
+	     if (!ipalloc_append(&tldia,&tldix)) return DNS_MEM;
+	   }
+         }
+     }
+   }
+#endif
+
  switch(resolve(sa,T_A))
   {
    case DNS_MEM: return DNS_MEM;
@@ -291,10 +350,17 @@
  while ((r = findip(T_A)) != 2)
   {
    ix.ip = ip;
-   ix.pref = pref;
+   ix.pref = spref;
    if (r == DNS_SOFT) return DNS_SOFT;
-   if (r == 1)
+   if (r == 1) {
+#ifdef FUCKVERISIGN
+     for (j = 0; j < tldia.len; j++)
+       if (byte_diff(&tldia.ix[j].ip, sizeof(struct ip_address), &ip) == 0)
+	 break;
+     if (j < tldia.len) continue;
+#endif
      if (!ipalloc_append(ia,&ix)) return DNS_MEM;
+   }
   }
  return 0;
 }
diff -ruN qmail-1.03-orig/dnscname.c qmail-1.03-ldap-20060201-orig/dnscname.c
--- qmail-1.03-orig/dnscname.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/dnscname.c	2006-02-25 11:00:55.000000000 +0100
@@ -8,7 +8,7 @@
 
 stralloc sa = {0};
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -21,5 +21,5 @@
  dnsdoe(dns_cname(&sa));
  substdio_putflush(subfdout,sa.s,sa.len);
  substdio_putsflush(subfdout,"\n");
- _exit(0);
+ return 0;
 }
diff -ruN qmail-1.03-orig/dnsdoe.h qmail-1.03-ldap-20060201-orig/dnsdoe.h
--- qmail-1.03-orig/dnsdoe.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/dnsdoe.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,6 +1,6 @@
 #ifndef DNSDOE_H
 #define DNSDOE_H
 
-extern void dnsdoe();
+extern void dnsdoe(int);
 
 #endif
diff -ruN qmail-1.03-orig/dnsfq.c qmail-1.03-ldap-20060201-orig/dnsfq.c
--- qmail-1.03-orig/dnsfq.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/dnsfq.c	2006-02-25 11:00:55.000000000 +0100
@@ -10,7 +10,7 @@
 stralloc sa = {0};
 ipalloc ia = {0};
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -28,5 +28,5 @@
  dnsdoe(dns_ptr(&sa,&ia.ix[0].ip));
  substdio_putflush(subfdout,sa.s,sa.len);
  substdio_putsflush(subfdout,"\n");
- _exit(0);
+ return 0;
 }
diff -ruN qmail-1.03-orig/dns.h qmail-1.03-ldap-20060201-orig/dns.h
--- qmail-1.03-orig/dns.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/dns.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,14 +1,18 @@
 #ifndef DNS_H
 #define DNS_H
 
+#include "ip.h"
+#include "ipalloc.h"
+#include "stralloc.h"
+
 #define DNS_SOFT -1
 #define DNS_HARD -2
 #define DNS_MEM -3
 
-void dns_init();
-int dns_cname();
-int dns_mxip();
-int dns_ip();
-int dns_ptr();
+void dns_init(int);
+int dns_cname(stralloc *);
+int dns_mxip(ipalloc *, stralloc *, unsigned long);
+int dns_ip(ipalloc *, stralloc *);
+int dns_ptr(stralloc *, struct ip_address *);
 
 #endif
diff -ruN qmail-1.03-orig/dnsip.c qmail-1.03-ldap-20060201-orig/dnsip.c
--- qmail-1.03-orig/dnsip.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/dnsip.c	2006-02-25 11:00:55.000000000 +0100
@@ -12,11 +12,11 @@
 stralloc sa = {0};
 ipalloc ia = {0};
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
- int j;
+ unsigned int j;
 
  if (!argv[1]) _exit(100);
 
@@ -30,5 +30,5 @@
    substdio_put(subfdout,temp,ip_fmt(temp,&ia.ix[j].ip));
    substdio_putsflush(subfdout,"\n");
   }
- _exit(0);
+ return 0;
 }
diff -ruN qmail-1.03-orig/dnsmxip.c qmail-1.03-ldap-20060201-orig/dnsmxip.c
--- qmail-1.03-orig/dnsmxip.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/dnsmxip.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "substdio.h"
 #include "subfd.h"
 #include "stralloc.h"
@@ -14,11 +16,11 @@
 stralloc sa = {0};
 ipalloc ia = {0};
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
- int j;
+ unsigned int j;
  unsigned long r;
 
  if (!argv[1]) _exit(100);
@@ -33,8 +35,8 @@
   {
    substdio_put(subfdout,temp,ip_fmt(temp,&ia.ix[j].ip));
    substdio_puts(subfdout," ");
-   substdio_put(subfdout,temp,fmt_ulong(temp,(unsigned long) ia.ix[j].pref));
+   substdio_put(subfdout,temp,fmt_uint(temp,ia.ix[j].pref));
    substdio_putsflush(subfdout,"\n");
   }
- _exit(0);
+ return 0;
 }
diff -ruN qmail-1.03-orig/dnsptr.c qmail-1.03-ldap-20060201-orig/dnsptr.c
--- qmail-1.03-orig/dnsptr.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/dnsptr.c	2006-02-25 11:00:55.000000000 +0100
@@ -11,7 +11,7 @@
 stralloc sa = {0};
 struct ip_address ip;
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -23,5 +23,5 @@
  dnsdoe(dns_ptr(&sa,&ip));
  substdio_putflush(subfdout,sa.s,sa.len);
  substdio_putsflush(subfdout,"\n");
- _exit(0);
+ return 0;
 }
diff -ruN qmail-1.03-orig/endian.c qmail-1.03-ldap-20060201-orig/endian.c
--- qmail-1.03-orig/endian.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/endian.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,34 @@
+/* endian.c
+ * ----------------------------------------------------------------------------
+ * "THE BEER-WARE LICENSE" (Revision 42):
+ * <jeker@n-r-g.com> wrote this file.  As long as you retain this notice you
+ * can do whatever you want with this stuff. If we meet some day, and you think
+ * this stuff is worth it, you can buy me a beer in return.       Claudio Jeker
+ * ----------------------------------------------------------------------------
+ *
+ *  This is a lowest-common-denominator (endian) program which should compile
+ *  under the default cc on any system, no matter how primitite ...
+ *  (even the SunOS one ;-) )
+ */
+
+#include <stdio.h>
+
+
+union endian_t {
+   unsigned char   c[8];
+   long   l;
+} endian;
+
+int main()
+{
+
+	endian.c[0]=0x80; endian.c[1]=0; endian.c[2]=0; endian.c[3]=0;
+	endian.c[4]=0;    endian.c[5]=0; endian.c[6]=0; endian.c[7]=0;
+   
+	if( endian.l < 0 )
+		printf( "-D__BIG_ENDIAN__" );
+	else
+		printf( "-D__LITTLE_ENDIAN__" );
+
+	return(0);
+}
diff -ruN qmail-1.03-orig/env.c qmail-1.03-ldap-20060201-orig/env.c
--- qmail-1.03-orig/env.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/env.c	2006-02-25 11:00:55.000000000 +0100
@@ -11,8 +11,8 @@
 #include "env.h"
 
 int env_isinit = 0; /* if env_isinit: */
-static int ea; /* environ is a pointer to ea+1 char*'s. */
-static int en; /* the first en of those are ALLOCATED. environ[en] is 0. */
+static unsigned int ea; /* environ is a pointer to ea+1 char*'s. */
+static unsigned int en; /* the first en of those are ALLOCATED. environ[en] is 0. */
 
 static void env_goodbye(i) int i;
 {
@@ -23,22 +23,26 @@
 
 static char *null = 0;
 
-void env_clear()
+void env_clear(void)
 {
  if (env_isinit) while (en) env_goodbye(0);
  else environ = &null;
 }
 
-static void env_unsetlen(s,len) char *s; int len;
+static void env_unsetlen(s,len) const char *s; unsigned int len;
 {
- int i;
- for (i = en - 1;i >= 0;--i)
+ unsigned int i;
+ 
+ i = en;
+ do {
+   --i;
    if (!str_diffn(s,environ[i],len))
      if (environ[i][len] == '=')
        env_goodbye(i);
+ } while (i > 0);
 }
 
-int env_unset(s) char *s;
+int env_unset(s) const char *s;
 {
  if (!env_isinit) if (!env_init()) return 0;
  env_unsetlen(s,str_len(s));
@@ -47,13 +51,13 @@
 
 static int env_add(s) char *s;
 {
- char *t;
+ const char *t;
  t = env_findeq(s);
  if (t) env_unsetlen(s,t - s);
  if (en == ea)
   {
    ea += 30;
-   if (!alloc_re(&environ,(en + 1) * sizeof(char *),(ea + 1) * sizeof(char *)))
+   if (!alloc_re((char **)&environ,(en + 1) * sizeof(char *),(ea + 1) * sizeof(char *)))
     { ea = en; return 0; }
   }
  environ[en++] = s;
@@ -61,7 +65,7 @@
  return 1;
 }
 
-int env_put(s) char *s;
+int env_put(s) const char *s;
 {
  char *u;
  if (!env_isinit) if (!env_init()) return 0;
@@ -72,10 +76,10 @@
  return 1;
 }
 
-int env_put2(s,t) char *s; char *t;
+int env_put2(s,t) const char *s; const char *t;
 {
  char *u;
- int slen;
+ unsigned int slen;
  if (!env_isinit) if (!env_init()) return 0;
  slen = str_len(s);
  u = alloc(slen + str_len(t) + 2);
@@ -87,10 +91,10 @@
  return 1;
 }
 
-int env_init()
+int env_init(void)
 {
  char **newenviron;
- int i;
+ unsigned int i;
  for (en = 0;environ[en];++en) ;
  ea = en + 10;
  newenviron = (char **) alloc((ea + 1) * sizeof(char *));
diff -ruN qmail-1.03-orig/env.h qmail-1.03-ldap-20060201-orig/env.h
--- qmail-1.03-orig/env.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/env.h	2006-02-25 11:00:55.000000000 +0100
@@ -3,14 +3,14 @@
 
 extern int env_isinit;
 
-extern int env_init();
-extern int env_put();
-extern int env_put2();
-extern int env_unset();
-extern /*@null@*/char *env_get();
-extern char *env_pick();
-extern void env_clear();
-extern char *env_findeq();
+extern int env_init(void);
+extern int env_put(const char *);
+extern int env_put2(const char *, const char *);
+extern int env_unset(const char *);
+extern /*@null@*/char *env_get(const char *);
+extern char *env_pick(void);
+extern void env_clear(void);
+extern const char *env_findeq(const char *);
 
 extern char **environ;
 
diff -ruN qmail-1.03-orig/envread.c qmail-1.03-ldap-20060201-orig/envread.c
--- qmail-1.03-orig/envread.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/envread.c	2006-02-25 11:00:55.000000000 +0100
@@ -2,26 +2,26 @@
 #include "str.h"
 
 extern /*@null@*/char *env_get(s)
-char *s;
+const char *s;
 {
-  int i;
+  unsigned int i;
   unsigned int slen;
   char *envi;
  
   slen = str_len(s);
-  for (i = 0;envi = environ[i];++i)
+  for (i = 0;(envi = environ[i]);++i)
     if ((!str_diffn(s,envi,slen)) && (envi[slen] == '='))
       return envi + slen + 1;
   return 0;
 }
 
-extern char *env_pick()
+extern char *env_pick(void)
 {
   return environ[0];
 }
 
-extern char *env_findeq(s)
-char *s;
+extern const char *env_findeq(s)
+const char *s;
 {
   for (;*s;++s)
     if (*s == '=')
diff -ruN qmail-1.03-orig/error.c qmail-1.03-ldap-20060201-orig/error.c
--- qmail-1.03-orig/error.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/error.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,4 +1,3 @@
-#include <errno.h>
 #include "error.h"
 
 /* warning: as coverage improves here, should update error_{str,temp} */
@@ -93,3 +92,18 @@
 #else
 -13;
 #endif
+
+int error_range =
+#ifdef ERANGE
+ERANGE;
+#else
+-14;
+#endif
+
+int error_proto =
+#ifdef EPROTO
+EPROTO;
+#else
+-15;
+#endif
+
